#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "lorenz.h"

void			ap_start(t_cam *cam)
{
	SDL_Event	event;
	t_time		time;
	char		run;
	GLUquadric	*spheric;

	run = 1;
	time.act = time.last = SDL_GetTicks();
	spheric = gluNewQuadric();
	while (run)
	{
		time.act = SDL_GetTicks();
		if (time.act - time.last > DELAY)
		{
			while (SDL_PollEvent(&event) && run)
                run = handle_event(&event, cam);
			run = handle_event(&event, cam);
			draw(cam, spheric, time.act - time.last);
			time.last = time.act;
		}
		else
			SDL_Delay(DELAY - (time.act - time.last));
	}
	gluDeleteQuadric(spheric);
}
