#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <math.h>
#include "lorenz.h"

static void	lorenz(GLUquadric *spheric)
{
	t_3f	coef = {10, 28, 2.667};
	float	h = 0.001099;
	t_3f	first = {0.0001, 0.0001, 0.0001};
	t_3f	second;
	int		c;

	for (c = 0; c < N; c++)
	{
		second.x = first.x + h * coef.x * (first.y - first.x);
		second.y = first.y + h * (first.x * (coef.y - first.z) - first.y);
		second.z = first.z + h * (first.x * first.y - coef.z * first.z);
/*
		second.x = (sin(first.y * -2.008) - first.z * cos(1.632 * first.x));
		second.y = (first.z * (sin(0.36 * first.x)) - cos(1.67 * first.y));
		second.z = sin(first.x);
*/
		glPushMatrix();
		glTranslatef(first.x, first.y, first.z);
		if (c > MIN && c % 7 == 0)
			gluSphere(spheric, 1, 10, 10);
		glPopMatrix();
		first.x = second.x;
		first.y = second.y;
		first.z = second.z;
	}
}

void		draw(t_cam *cam, GLUquadric *spheric, int elapsed_time)
{
	move(cam, elapsed_time);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(cam->pos.x, cam->pos.y, cam->pos.z, cam->look.x, cam->look.y, cam->look.z, 0, 0, 1);
	lorenz(spheric);
	glFlush();
	SDL_GL_SwapBuffers();
}
