#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>
#include <math.h>
#include "lorenz.h"

void		handle_mouse(SDL_MouseMotionEvent *event, t_cam *cam)
{
    float	tmp;

    cam->theta -= event->xrel * cam->sensib;
    cam->phi -= event->yrel * cam->sensib;
    if (cam->phi > 89)
        cam->phi = 89;
   else if (cam->phi < -89)
        cam->phi = -89;

    tmp = cos(cam->phi * M_PI / 180);
    cam->forward.x = tmp * cos(cam->theta * M_PI / 180);
    cam->forward.y = tmp * sin(cam->theta * M_PI / 180);
    cam->forward.z = sin(cam->phi * M_PI / 180);

    cam->look.x = cam->forward.x + cam->pos.x;
    cam->look.y = cam->forward.y + cam->pos.y;
    cam->look.z = cam->forward.z + cam->pos.z;
}

void		handle_key_up(SDL_KeyboardEvent *event, t_cam *cam)
{
    if (event->keysym.sym == SDLK_w)
        cam->key_state[0] = FALSE;
    else if (event->keysym.sym == SDLK_s)
        cam->key_state[1] = FALSE;
}

void		handle_key_down(SDL_KeyboardEvent *event, t_cam *cam)
{
    if (event->keysym.sym == SDLK_w)
        cam->key_state[0] = TRUE;
    else if (event->keysym.sym == SDLK_s)
        cam->key_state[1] = TRUE;
}

char		handle_event(SDL_Event *event, t_cam *cam)
{
	if (event->type == SDL_QUIT || (event->type == SDL_KEYUP && event->key.keysym.sym == SDLK_ESCAPE))
		return (FALSE);
    if (event->type == SDL_MOUSEMOTION)
        handle_mouse(&(event->motion), cam);
    else if (event->type == SDL_KEYDOWN)
        handle_key_down(&(event->key), cam);
    else if (event->type == SDL_KEYUP)
        handle_key_up(&(event->key), cam);
	return (TRUE);
}
